<template>
  <div
    class="ui modal"
    id="new-pavillon-modal"
  >
    <i class="close icon"></i>
    <div class="header">
      Ajouter un nouveau pavillon
    </div>
    <div class="content">
      <div
        class="ui form"
        @submit.prevent="submit"
      >
        <div class="fields">
          <div class="six wide required field">
            <label>Nom du pavillon</label>
            <input
              placeholder="Nom"
              type="text"
              v-model="name"
              @keyup.enter="submit"
            >
          </div>
        </div>
        <div class="fields">
          <div class="six wide required field">
            <label>A commander tous les jours</label>
            <checkboxes-side-menus
              :sideMenusSelected="data_sideMenusSelected"
              @sideMenuChanged="sideMenuChanged"
            >
            </checkboxes-side-menus>
          </div>
        </div>
      </div>
    </div>

    <div class="actions">
      <div
        class="ui toggle checkbox"
        :class="addAnother ? 'checked' : ''"
        @click="toggleAddAnother"
      >
        <input
          name="addAnother"
          type="checkbox"
          class="hidden"
          tabindex="0"
          :checked="addAnother"
        >
        <label>Ajouter un autre ensuite</label>
      </div>

      <div
        class="ui red basic button"
        @click="cancel"
      >Anuler</div>

      <div
        class="ui primary button"
        :class="loading ? 'loading disabled' : ''"
        @click="submit"
      >OK</div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'

import store from '@/store/Store'
import CheckboxesSideMenus from '@/components/sideMenus/CheckboxesSideMenus'

export default {
  name: 'ModalNewPavillon',
  store,
  data () {
    return {
      addAnother: false,
      name: '',
      data_sideMenusSelected: []
    }
  },
  mounted () {
    // eslint-disable-next-line
    $('#new-pavillon-modal')
      .modal('setting', 'transition', 'scale')
  },
  methods: {
    ...mapActions({
      addPavillon: 'PavillonsStore/addPavillon'
    }),
    toggleAddAnother () {
      this.addAnother = !this.addAnother
    },
    sideMenuChanged (sideMenu) {
      // check if contains
      let contains = false
      this.data_sideMenusSelected.forEach(sms => {
        if (sms._id === sideMenu._id) {
          contains = true
        }
      })

      if (contains) {
        // suppression
        this.data_sideMenusSelected = this.data_sideMenusSelected.filter(sms => sms._id !== sideMenu._id)
      } else {
        // ajout
        this.data_sideMenusSelected.push(sideMenu)
      }
    },
    cancel () {
      // eslint-disable-next-line
      $('#new-pavillon-modal')
        .modal('hide')
    },
    submit () {
      var self = this

      let pavillon = {
        name: this.name,
        sideMenus: this.data_sideMenusSelected.map(s => s._id)
      }

      this.addPavillon(pavillon)
        .then((response) => {
          this.$toastr.s(pavillon.name + ' bien ajouté')
          if (!self.addAnother) {
            // eslint-disable-next-line
            $('#new-pavillon-modal')
              .modal('hide')
          }
          this.emptyModal()
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    emptyModal () {
      // vider les champs
      this.name = ''
    }
  },
  computed: {
    ...mapGetters({
      loading: 'loading'
    })
  },
  components: {
    CheckboxesSideMenus
  }
}
</script>
